// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function Createu8(value){
  var n;

  n = {};
  n.number = ConvertToU8(value);

  return n;
}
function Numberu8(number){
  var n;

  n = {};
  n.number = ConvertToU8(number);

  return n;
}
function Assignu8(n, number){
  n.number = ConvertToU8(number);
}
function U8IsValid(n){
  var valid;

  if(IsInteger(n.number)){
    if(n.number >= 0 && n.number < Math.pow(2, 8)){
      valid = true;
    }else{
      valid = false;
    }
  }else{
    valid = false;
  }

  return valid;
}
function WillOverflowu8(number){
  var overflow;

  if(number >= 0 && number < Math.pow(2, 8)){
    overflow = false;
  }else{
    overflow = true;
  }

  return overflow;
}
function ConvertToU8(x){
  if(Math.abs(x) < Math.pow(2, 32) && Math.abs(x) >=  -(Math.pow(2, 31))){
    if( !IsInteger(x) ){
      x = Truncate(x);
    }

    if(x < 0){
      x = Math.pow(2, 32) + x;
    }

    if(x >= Math.pow(2, 8)){
      x = x%Math.pow(2, 8);
    }
  }else{
    x = 0;
  }

  return x;
}
function ToStringu8(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 3;

  decimal = n.number;

  characterReference = {};

  digits = 3;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(10, digits - i - 1));
    d = d%10;

    GetSingleDigitCharacterFromNumberWithCheck(d, 10, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function ToHexStringu8(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 2;

  decimal = n.number;

  characterReference = {};

  digits = 2;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(2, 4*(digits - i - 1)));
    d = d%Math.pow(2, 4);

    GetSingleDigitCharacterFromNumberWithCheck(d, 16, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function Addu8(a, b, c){
  Assignu8(a, b.number + c.number);
}
function AddIntou8(a, b){
  Addu8(a, a, b);
}
function Subtractu8(a, b, c){
  Assignu8(a, b.number - c.number);
}
function SubtractIntou8(a, b, c){
  Subtractu8(a, a, b);
}
function Multiplyu8(a, b, c){
  Assignu8(a, b.number*c.number);
}
function MultiplyIntou8(a, b, c){
  Multiplyu8(a, a, b);
}
function Divideu8(a, b, c){
  var success;

  if(c.number != 0){
    Assignu8(a, Truncate(b.number/c.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DivideIntou8(a, b){
  return Divideu8(a, a, b);
}
function Positiveu8(a){
  a.number =  +a.number;
}
function Factorialu8(x){
  Assignu8(x, ConvertToU8(Factorial(x.number)));
}
function Logarithmu8(x){
  Assignu8(x, ConvertToU8(Logarithm(x.number)));
}
function NaturalLogarithmu8(x){
  Assignu8(x, ConvertToU8(NaturalLogarithm(x.number)));
}
function Tanu8(x){
  Assignu8(x, ConvertToU8(Tan(x.number)));
}
function Atan2_u8(a, y, x){
  Assignu8(a, ConvertToU8(Atan2(y.number, x.number)));
}
function Squarerootu8(x){
  Assignu8(x, ConvertToU8(Math.sqrt(x.number)));
}
function Expu8(x){
  Assignu8(x, ConvertToU8(Exp(x.number)));
}
function DivisibleByu8(a, b){
  return ((a.number%b.number) == 0);
}
function Combinationsu8(x, n, k){
  var success;

  if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
    Assignu8(x, ConvertToU8(Combinations(n.number, k.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Permutationsu8(x, n, k){
  var success;

  if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
    Assignu8(x, ConvertToU8(Permutations(n.number, k.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function EpsilonCompareu8(a, b, epsilon){
  return EpsilonCompare(a.number, b.number, epsilon.number);
}
function GreatestCommonDivisoru8(x, a, b){
  var success;

  if(a.number >= 0 && b.number >= 0){
    Assignu8(x, GreatestCommonDivisor(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function GCDWithSubtractionu8(x, a, b){
  var success;

  if(a.number >= 0 && b.number >= 0){
    Assignu8(x, GCDWithSubtraction(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultipleu8(x, a, b){
  var success;

  if(a.number != 0 && b.number != 0){
    Assignu8(x, LeastCommonMultiple(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Maxu8(x, a, b){
  Assignu8(x, Max(a.number, b.number));
}
function Minu8(x, a, b){
  Assignu8(x, Min(a.number, b.number));
}
function Poweru8(x, a, b){
  var success;

  if(a.number != 0 || b.number != 0){
    if( !(a.number < 0 &&  !IsInteger(b.number) ) ){
      Assignu8(x, Power(a.number, b.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function Createu16(value){
  var n;

  n = {};
  n.number = ConvertToU16(value);

  return n;
}
function Numberu16(number){
  var n;

  n = {};
  n.number = ConvertToU16(number);

  return n;
}
function Assignu16(n, number){
  n.number = ConvertToU16(number);
}
function u16IsValid(n){
  var valid;

  if(IsInteger(n.number)){
    if(n.number >= 0 && n.number < Math.pow(2, 16)){
      valid = true;
    }else{
      valid = false;
    }
  }else{
    valid = false;
  }

  return valid;
}
function WillOverflowu16(number){
  var overflow;

  if(number >= 0 && number < Math.pow(2, 16)){
    overflow = false;
  }else{
    overflow = true;
  }

  return overflow;
}
function ConvertToU16(x){
  if(Math.abs(x) < Math.pow(2, 32) && Math.abs(x) >=  -(Math.pow(2, 31))){
    if( !IsInteger(x) ){
      x = Truncate(x);
    }

    if(x < 0){
      x = Math.pow(2, 32) + x;
    }

    if(x >= Math.pow(2, 16)){
      x = x%Math.pow(2, 16);
    }
  }else{
    x = 0;
  }

  return x;
}
function ToStringu16(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 5;

  decimal = n.number;

  characterReference = {};

  digits = 5;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(10, digits - i - 1));
    d = d%10;

    GetSingleDigitCharacterFromNumberWithCheck(d, 10, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function ToHexStringu16(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 4;

  decimal = n.number;

  characterReference = {};

  digits = 4;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(2, 4*(digits - i - 1)));
    d = d%Math.pow(2, 4);

    GetSingleDigitCharacterFromNumberWithCheck(d, 16, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function Addu16(a, b, c){
  Assignu16(a, b.number + c.number);
}
function AddIntou16(a, b){
  Addu16(a, a, b);
}
function Subtractu16(a, b, c){
  Assignu16(a, b.number - c.number);
}
function SubtractIntou16(a, b, c){
  Subtractu16(a, a, b);
}
function Multiplyu16(a, b, c){
  Assignu16(a, b.number*c.number);
}
function MultiplyIntou16(a, b, c){
  Multiplyu16(a, a, b);
}
function Divideu16(a, b, c){
  var success;

  if(c.number != 0){
    Assignu16(a, Truncate(b.number/c.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DivideIntou16(a, b){
  return Divideu16(a, a, b);
}
function Positiveu16(a){
  a.number =  +a.number;
}
function Factorialu16(x){
  Assignu16(x, ConvertToU16(Factorial(x.number)));
}
function Logarithmu16(x){
  Assignu16(x, ConvertToU16(Logarithm(x.number)));
}
function NaturalLogarithmu16(x){
  Assignu16(x, ConvertToU16(NaturalLogarithm(x.number)));
}
function Tanu16(x){
  Assignu16(x, ConvertToU16(Tan(x.number)));
}
function Atan2_u16(a, y, x){
  Assignu16(a, ConvertToU16(Atan2(y.number, x.number)));
}
function Squarerootu16(x){
  Assignu16(x, ConvertToU16(Math.sqrt(x.number)));
}
function Expu16(x){
  Assignu16(x, ConvertToU16(Exp(x.number)));
}
function DivisibleByu16(a, b){
  return ((a.number%b.number) == 0);
}
function Combinationsu16(x, n, k){
  var success;

  if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
    Assignu16(x, ConvertToU16(Combinations(n.number, k.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Permutationsu16(x, n, k){
  var success;

  if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
    Assignu16(x, ConvertToU16(Permutations(n.number, k.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function EpsilonCompareu16(a, b, epsilon){
  return EpsilonCompare(a.number, b.number, epsilon.number);
}
function GreatestCommonDivisoru16(x, a, b){
  var success;

  if(a.number >= 0 && b.number >= 0){
    Assignu16(x, GreatestCommonDivisor(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function GCDWithSubtractionu16(x, a, b){
  var success;

  if(a.number >= 0 && b.number >= 0){
    Assignu16(x, GCDWithSubtraction(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultipleu16(x, a, b){
  var success;

  if(a.number != 0 && b.number != 0){
    Assignu16(x, LeastCommonMultiple(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Maxu16(x, a, b){
  Assignu16(x, Max(a.number, b.number));
}
function Minu16(x, a, b){
  Assignu16(x, Min(a.number, b.number));
}
function Poweru16(x, a, b){
  var success;

  if(a.number != 0 || b.number != 0){
    if( !(a.number < 0 &&  !IsInteger(b.number) ) ){
      Assignu16(x, Power(a.number, b.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function Creates8(number){
  var fp;

  fp = {};
  fp.number = ConvertToS8(number);

  return fp;
}
function ConvertToS8(x){
  if(Math.abs(x) < Math.pow(2, 32) && Math.abs(x) >=  -(Math.pow(2, 31))){
    if( !IsInteger(x) ){
      x = Truncate(x);
    }

    if(x < 0){
      x = Math.pow(2, 32) + x;
    }

    if(x >= Math.pow(2, 8)){
      x = x%Math.pow(2, 8);
    }

    if(x >= Math.pow(2, 8 - 1)){
      x =  -128 + (x - 127) - 1;
    }
  }else{
    x = 0;
  }

  return x;
}
function ToStrings8(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 4;

  decimal = n.number;

  if(decimal < 0){
    string[0] = '-';
    decimal =  -decimal;
  }else{
    string[0] = '+';
  }

  characterReference = {};

  digits = 3;
  digitPosition = 1;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(10, digits - i - 1));
    d = d%10;

    GetSingleDigitCharacterFromNumberWithCheck(d, 10, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function ToHexStrings8(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 2;

  decimal = n.number;

  characterReference = {};

  digits = 2;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(2, 4*(digits - i - 1)));
    d = d%Math.pow(2, 4);

    GetSingleDigitCharacterFromNumberWithCheck(d, 16, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function Numbers8(number){
  var fp;

  fp = {};
  fp.number = ConvertToS8(number);

  return fp;
}
function Assigns8(n, number){
  n.number = ConvertToS8(number);
}
function S8IsValids8(n){
  var valid;

  if(IsInteger(n.number)){
    if(n.number >= Math.pow(2, 8 - 1) && n.number < Math.pow(2, 8 - 1)){
      valid = true;
    }else{
      valid = false;
    }
  }else{
    valid = false;
  }

  return valid;
}
function WillOverflows8(number){
  var overflow;

  if(Math.abs(number) < Math.pow(2, 8 - 1)){
    overflow = false;
  }else{
    overflow = true;
  }

  return overflow;
}
function Adds8(a, b, c){
  Assigns8(a, ConvertToS8(b.number + c.number));
}
function AddIntos8(a, b){
  Adds8(a, a, b);
}
function Subtracts8(a, b, c){
  Assigns8(a, ConvertToS8(b.number - c.number));
}
function SubtractIntos8(a, b){
  Subtracts8(a, a, b);
}
function Multiplys8(a, b, c){
  Assigns8(a, ConvertToS8(b.number*c.number));
}
function MultiplyIntos8(a, b){
  Multiplys8(a, a, b);
}
function Divides8(a, b, c){
  var success;

  if(c.number != 0){
    Assigns8(a, Truncate(b.number/c.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DivideIntos8(a, b){
  return Divides8(a, a, b);
}
function Negates8(a){
  a.number =  -a.number;
}
function Positives8(a){
  a.number =  +a.number;
}
function Factorials8(x){
  var success;

  if(x.number >= 0){
    Assigns8(x, Factorial(x.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Truncates8(x){
  x.number = Truncate(x.number);
}
function Absolutes8(x){
  x.number = Math.abs(x.number);
}
function Logarithms8(x){
  var success;

  if(x.number > 0){
    Assigns8(x, ConvertToS8(Logarithm(x.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function NaturalLogarithms8(x){
  var success;

  if(x.number > 0){
    Assigns8(x, ConvertToS8(NaturalLogarithm(x.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Tans8(x){
  Assigns8(x, ConvertToS8(Tan(x.number)));
}
function Atans8(x){
  Assigns8(x, ConvertToS8(Atan(x.number)));
}
function Atan2_s8(a, y, x){
  Assigns8(a, ConvertToS8(Atan2(y.number, x.number)));
}
function Squareroots8(x){
  var success;

  if(x.number >= 0){
    Assigns8(x, Math.sqrt(x.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Exps8(x){
  Assigns8(x, Exp(x.number));
}
function DivisibleBys8(a, b){
  return ((a.number%b.number) == 0);
}
function Combinationss8(x, n, k){
  var success;

  if(IsInteger(n.number) && IsInteger(k.number)){
    if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
      Assigns8(x, Combinations(n.number, k.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function Permutationss8(x, n, k){
  var success;

  if(IsInteger(n.number) && IsInteger(k.number)){
    if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
      Assigns8(x, Permutations(n.number, k.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function EpsilonCompares8(a, b, epsilon){
  return EpsilonCompare(a.number, b.number, epsilon.number);
}
function GreatestCommonDivisors8(x, a, b){
  var success;

  if(IsInteger(a.number) && IsInteger(b.number)){
    if(a.number >= 0 && b.number >= 0){
      Assigns8(x, GreatestCommonDivisor(a.number, b.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function GCDWithSubtractions8(x, a, b){
  var success;

  if(IsInteger(a.number) && IsInteger(b.number)){
    if(a.number >= 0 && b.number >= 0){
      Assigns8(x, GCDWithSubtraction(a.number, b.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function IsIntegers8(a){
  return IsInteger(a.number);
}
function LeastCommonMultiples8(x, a, b){
  var success;

  if(IsInteger(a.number) && IsInteger(b.number)){
    if(a.number != 0 && b.number != 0){
      Assigns8(x, LeastCommonMultiple(a.number, b.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function Signs8(a){
  return Sign(a.number);
}
function Maxs8(x, a, b){
  x.number = Max(a.number, b.number);
}
function Mins8(x, a, b){
  x.number = Min(a.number, b.number);
}
function Powers8(x, a, b){
  var success;

  if(a.number != 0 || b.number != 0){
    if( !(a.number < 0 &&  !IsInteger(b.number) ) ){
      Assigns8(x, ConvertToS8(Power(a.number, b.number)));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function Createu32(value){
  var n;

  n = {};
  n.number = ConvertToU32(value);

  return n;
}
function Numberu32(number){
  var n;

  n = {};
  n.number = ConvertToU32(number);

  return n;
}
function Assignu32(n, number){
  n.number = ConvertToU32(number);
}
function u32IsValid(n){
  var valid;

  if(IsInteger(n.number)){
    if(n.number >= 0 && n.number < Math.pow(2, 32)){
      valid = true;
    }else{
      valid = false;
    }
  }else{
    valid = false;
  }

  return valid;
}
function WillOverflowu32(number){
  var overflow;

  if(number >= 0 && number < Math.pow(2, 32)){
    overflow = false;
  }else{
    overflow = true;
  }

  return overflow;
}
function ConvertToU32(x){
  if( !IsInteger(x) ){
    x = Truncate(x);
  }

  if(x < 0){
    x = ( -x)%Math.pow(2, 32);
    x = Math.pow(2, 32) - x;
  }

  if(x >= Math.pow(2, 32)){
    x = x%Math.pow(2, 32);
  }

  return x;
}
function ToStringu32(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 10;

  decimal = n.number;

  characterReference = {};

  digits = 10;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(10, digits - i - 1));
    d = d%10;

    GetSingleDigitCharacterFromNumberWithCheck(d, 10, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function ToHexStringu32(n){
  var string;
  var digits;
  var digitPosition;
  var i, d, decimal;
  var characterReference;

  string = [];
  string.length = 8;

  decimal = n.number;

  characterReference = {};

  digits = 8;
  digitPosition = 0;

  for(i = 0; i < digits; i = i + 1){
    d = Math.floor(decimal/Math.pow(2, 4*(digits - i - 1)));
    d = d%Math.pow(2, 4);

    GetSingleDigitCharacterFromNumberWithCheck(d, 16, characterReference);
    string[digitPosition] = characterReference.characterValue;

    digitPosition = digitPosition + 1;
  }

  delete(characterReference);

  return string;
}
function Addu32(a, b, c){
  Assignu32(a, b.number + c.number);
}
function AddIntou32(a, b){
  Addu32(a, a, b);
}
function Subtractu32(a, b, c){
  Assignu32(a, b.number - c.number);
}
function SubtractIntou32(a, b, c){
  Subtractu32(a, a, b);
}
function Multiplyu32(a, b, c){
  Assignu32(a, b.number*c.number);
}
function MultiplyIntou32(a, b, c){
  Multiplyu32(a, a, b);
}
function Divideu32(a, b, c){
  var success;

  if(c.number != 0){
    Assignu32(a, Truncate(b.number/c.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DivideIntou32(a, b){
  return Divideu32(a, a, b);
}
function Positiveu32(a){
  a.number =  +a.number;
}
function Factorialu32(x){
  Assignu32(x, ConvertToU32(Factorial(x.number)));
}
function Logarithmu32(x){
  Assignu32(x, ConvertToU32(Logarithm(x.number)));
}
function NaturalLogarithmu32(x){
  Assignu32(x, ConvertToU32(NaturalLogarithm(x.number)));
}
function Tanu32(x){
  Assignu32(x, ConvertToU32(Tan(x.number)));
}
function Atan2_u32(a, y, x){
  Assignu32(a, ConvertToU32(Atan2(y.number, x.number)));
}
function Squarerootu32(x){
  Assignu32(x, ConvertToU32(Math.sqrt(x.number)));
}
function Expu32(x){
  Assignu32(x, ConvertToU32(Exp(x.number)));
}
function DivisibleByu32(a, b){
  return ((a.number%b.number) == 0);
}
function Combinationsu32(x, n, k){
  var success;

  if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
    Assignu32(x, ConvertToU32(Combinations(n.number, k.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Permutationsu32(x, n, k){
  var success;

  if(n.number >= 1 && k.number >= 0 && n.number >= k.number){
    Assignu32(x, ConvertToU32(Permutations(n.number, k.number)));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function EpsilonCompareu32(a, b, epsilon){
  return EpsilonCompare(a.number, b.number, epsilon.number);
}
function GreatestCommonDivisoru32(x, a, b){
  var success;

  if(a.number >= 0 && b.number >= 0){
    Assignu32(x, GreatestCommonDivisor(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function GCDWithSubtractionu32(x, a, b){
  var success;

  if(a.number >= 0 && b.number >= 0){
    Assignu32(x, GCDWithSubtraction(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultipleu32(x, a, b){
  var success;

  if(a.number != 0 && b.number != 0){
    Assignu32(x, LeastCommonMultiple(a.number, b.number));
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Maxu32(x, a, b){
  Assignu32(x, Max(a.number, b.number));
}
function Minu32(x, a, b){
  Assignu32(x, Min(a.number, b.number));
}
function Poweru32(x, a, b){
  var success;

  if(a.number != 0 || b.number != 0){
    if( !(a.number < 0 &&  !IsInteger(b.number) ) ){
      Assignu32(x, Power(a.number, b.number));
      success = true;
    }else{
      success = false;
    }
  }else{
    success = false;
  }

  return success;
}
function Signed32BitIntegerIndefinateValue(){
  return  -(Math.pow(2, 32 - 1));
}
function NumberToSigned32Bit(n){
  var lowerbound, upperbound;

  lowerbound =  -(Math.pow(2, 32 - 1));
  upperbound = Math.pow(2, 32 - 1) - 1;

  n = Truncate(n);

  if(n >= lowerbound && n <= upperbound){
  }else{
    n = Signed32BitIntegerIndefinateValue();
  }

  return n;
}
function Signed32BitAdd(a, b){
  var x;
  x = NumberToSigned32Bit(a) + NumberToSigned32Bit(b);
  x = NumberToSigned32Bit(x);
  return x;
}
function Signed32BitSub(a, b){
  var x;
  x = NumberToSigned32Bit(a) - NumberToSigned32Bit(b);
  x = NumberToSigned32Bit(x);
  return x;
}
function Signed32BitMul(a, b){
  var x;
  x = NumberToSigned32Bit(a)*NumberToSigned32Bit(b);
  x = NumberToSigned32Bit(x);
  return x;
}
function Signed32BitDiv(a, b){
  var x;
  x = NumberToSigned32Bit(a)/NumberToSigned32Bit(b);
  x = NumberToSigned32Bit(x);
  return x;
}
function testS8(failures){
  var a, b, c, x1, x2, t1, t2, t3;
  var success;

  /*a = Createu8(-122d); */
  AssertEquals(ConvertToS8( -122),  -122, failures);
  AssertEquals(ConvertToS8(0), 0, failures);
  AssertEquals(ConvertToS8(255),  -1, failures);
  AssertEquals(ConvertToS8(256), 0, failures);
  AssertEquals(ConvertToS8(257), 1, failures);
  AssertEquals(ConvertToS8( -257),  -1, failures);
  AssertEquals(ConvertToS8( -1144),  -120, failures);

  a = Creates8(22);

  AssertStringEquals(ToStrings8(a), "+022".split(''), failures);
  /*AssertStringEquals(ToHexStrings8(a), "16".toCharArray(), failures); */
  Logarithms8(a);

  AssertStringEquals(ToStrings8(a), "+001".split(''), failures);
  /*AssertStringEquals(ToHexStrings8(a), "01".toCharArray(), failures); */
  Negates8(a);
  AssertStringEquals(ToStrings8(a), "-001".split(''), failures);

  a = Creates8(22);
  b = Creates8(5);

  success = DivideIntos8(a, b);
  AssertTrue(success, failures);
  AssertStringEquals(ToStrings8(a), "+004".split(''), failures);
  /*AssertStringEquals(ToHexStrings8(a), "04".toCharArray(), failures); */
  a = Creates8(22);
  b = Creates8(5);
  AddIntos8(a, b);
  AssertEquals(a.number, 27, failures);

  a = Creates8(1);
  b = Creates8(7);
  c = Creates8(6);

  /* # x1 = (-b + sqrt(pow(b, 2) - 4*a*c))/(2*a); */
  t1 = {};
  t2 = {};
  t3 = {};
  x1 = {};
  /* x1 = (t1 + sqrt(pow(b, 2) - 4*a*c))/(2*a); */
  Assigns8(t1, b.number);
  Negates8(t1);
  /* x1 = (t1 + sqrt(pow(b, 2) - t2*c))/(2*a); */
  Multiplys8(t2, Numbers8(4), a);
  /* x1 = (t1 + sqrt(pow(b, 2) - t2))/(2*a); */
  MultiplyIntos8(t2, c);
  /* x1 = (t1 + sqrt(t3 - t2))/(2*a); */
  Powers8(t3, b, Numbers8(2));
  /* x1 = (t1 + sqrt(t3))/(2*a); */
  SubtractIntos8(t3, t2);
  /* x1 = (t1 + t3)/(2*a); */
  Squareroots8(t3);
  /* x1 = t1/(2*a); */
  AddIntos8(t1, t3);
  /* x1 = t1/t2; */
  Multiplys8(t2, Numbers8(2), a);
  Divides8(x1, t1, t2);

  /* # x2 = (-b - sqrt(pow(b, 2) - 4*a*c))/(2*a); */
  x2 = {};
  /* x1 = (t1 + sqrt(pow(b, 2) - 4*a*c))/(2*a); */
  Assigns8(t1, b.number);
  Negates8(t1);
  /* x2 = (t1 - sqrt(pow(b, 2) - t2*c))/(2*a); */
  Multiplys8(t2, Numbers8(4), a);
  /* x2 = (t1 - sqrt(pow(b, 2) - t2))/(2*a); */
  MultiplyIntos8(t2, c);
  /* x2 = (t1 - sqrt(t3 - t2))/(2*a); */
  Powers8(t3, b, Numbers8(2));
  /* x2 = (t1 - sqrt(t3))/(2*a); */
  SubtractIntos8(t3, t2);
  /* x2 = (t1 - t3)/(2*a); */
  Squareroots8(t3);
  /* x2 = t1/(2*a); */
  SubtractIntos8(t1, t3);
  /* x2 = t1/t2; */
  Multiplys8(t2, Numbers8(2), a);
  Divides8(x2, t1, t2);

  AssertEquals(x1.number,  -1, failures);
  AssertEquals(x2.number,  -6, failures);
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  testU8(failures);
  testU16(failures);
  testU32(failures);
  testS8(failures);

  return failures.numberValue;
}
function testU32(failures){
  var a, b;
  var success;

  /*a = Createu8(-122d); */
  AssertEquals(ConvertToU32( -122), 4294967296 - 122, failures);
  AssertEquals(ConvertToU32(0), 0, failures);
  AssertEquals(ConvertToU32(255), 255, failures);
  AssertEquals(ConvertToU32(256), 256, failures);
  AssertEquals(ConvertToU32(257), 257, failures);
  AssertEquals(ConvertToU32(65535), 65535, failures);
  AssertEquals(ConvertToU32(65536), 65536, failures);
  AssertEquals(ConvertToU32(65537), 65537, failures);
  AssertEquals(ConvertToU32(4294967295), 4294967295, failures);

  AssertEquals(ConvertToU32( -257), 4294967296 - 257, failures);
  AssertEquals(ConvertToU32( -1144), 4294967296 - 1144, failures);

  a = Createu32(22);

  AssertStringEquals(ToStringu32(a), "0000000022".split(''), failures);
  AssertStringEquals(ToHexStringu32(a), "00000016".split(''), failures);

  Logarithmu32(a);

  AssertStringEquals(ToStringu32(a), "0000000001".split(''), failures);
  AssertStringEquals(ToHexStringu32(a), "00000001".split(''), failures);

  a = Createu32(22);
  b = Createu32(5);

  success = DivideIntou32(a, b);
  AssertTrue(success, failures);
  AssertStringEquals(ToStringu32(a), "0000000004".split(''), failures);
  AssertStringEquals(ToHexStringu32(a), "00000004".split(''), failures);

  b = Createu32(65535);
  AssertStringEquals(ToStringu32(b), "0000065535".split(''), failures);
  AssertStringEquals(ToHexStringu32(b), "0000FFFF".split(''), failures);

  b = Createu32(4294967295);
  AssertStringEquals(ToStringu32(b), "4294967295".split(''), failures);
  AssertStringEquals(ToHexStringu32(b), "FFFFFFFF".split(''), failures);
}
function testU8(failures){
  var a, b, c, x1, x2, t1;
  var success;

  /*a = Createu8(-122d); */
  AssertEquals(ConvertToU8( -122), 134, failures);
  AssertEquals(ConvertToU8(0), 0, failures);
  AssertEquals(ConvertToU8(255), 255, failures);
  AssertEquals(ConvertToU8(256), 0, failures);
  AssertEquals(ConvertToU8(257), 1, failures);
  AssertEquals(ConvertToU8( -257), 255, failures);
  AssertEquals(ConvertToU8( -1144), 136, failures);

  a = Createu8(22);

  AssertStringEquals(ToStringu8(a), "022".split(''), failures);
  AssertStringEquals(ToHexStringu8(a), "16".split(''), failures);

  Logarithmu8(a);

  AssertStringEquals(ToStringu8(a), "001".split(''), failures);
  AssertStringEquals(ToHexStringu8(a), "01".split(''), failures);

  a = Createu8(22);
  b = Createu8(5);

  success = DivideIntou8(a, b);
  AssertTrue(success, failures);
  AssertStringEquals(ToStringu8(a), "004".split(''), failures);
  AssertStringEquals(ToHexStringu8(a), "04".split(''), failures);

  a = Createu8(22);
  b = Createu8(5);
  AddIntou8(a, b);
  AssertEquals(a.number, 27, failures);
}
function testU16(failures){
  var a, b;
  var success;

  /*a = Createu8(-122d); */
  AssertEquals(ConvertToU16( -122), 65536 - 122, failures);
  AssertEquals(ConvertToU16(0), 0, failures);
  AssertEquals(ConvertToU16(255), 255, failures);
  AssertEquals(ConvertToU16(256), 256, failures);
  AssertEquals(ConvertToU16(257), 257, failures);
  AssertEquals(ConvertToU16(65535), 65535, failures);
  AssertEquals(ConvertToU16(65536), 0, failures);
  AssertEquals(ConvertToU16(65537), 1, failures);
  AssertEquals(ConvertToU16( -257), 65279, failures);
  AssertEquals(ConvertToU16( -1144), 65536 - 1144, failures);

  a = Createu16(22);

  AssertStringEquals(ToStringu16(a), "00022".split(''), failures);
  AssertStringEquals(ToHexStringu16(a), "0016".split(''), failures);

  Logarithmu16(a);

  AssertStringEquals(ToStringu16(a), "00001".split(''), failures);
  AssertStringEquals(ToHexStringu16(a), "0001".split(''), failures);

  a = Createu16(22);
  b = Createu16(5);

  success = DivideIntou16(a, b);
  AssertTrue(success, failures);
  AssertStringEquals(ToStringu16(a), "00004".split(''), failures);
  AssertStringEquals(ToHexStringu16(a), "0004".split(''), failures);

  b = Createu16(65535);
  AssertStringEquals(ToStringu16(b), "65535".split(''), failures);
  AssertStringEquals(ToHexStringu16(b), "FFFF".split(''), failures);
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function Negate(x){
  return  -x;
}
function Positive(x){
  return  +x;
}
function Factorial(x){
  var i, f;

  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function Round(x){
  return Math.floor(x + 0.5);
}
function BankersRound(x){
  var r;

  if(Absolute(x - Truncate(x)) == 0.5){
    if( !DivisibleBy(Round(x), 2) ){
      r = Round(x) - 1;
    }else{
      r = Round(x);
    }
  }else{
    r = Round(x);
  }

  return r;
}
function Ceil(x){
  return Math.ceil(x);
}
function Floor(x){
  return Math.floor(x);
}
function Truncate(x){
  var t;

  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function Absolute(x){
  return Math.abs(x);
}
function Logarithm(x){
  return Math.log10(x);
}
function NaturalLogarithm(x){
  return Math.log(x);
}
function Sin(x){
  return Math.sin(x);
}
function Cos(x){
  return Math.cos(x);
}
function Tan(x){
  return Math.tan(x);
}
function Asin(x){
  return Math.asin(x);
}
function Acos(x){
  return Math.acos(x);
}
function Atan(x){
  return Math.atan(x);
}
function Atan2(y, x){
  var a;

  /* Atan2 is an invalid operation when x = 0 and y = 0, but this method does not return errors. */
  a = 0;

  if(x > 0){
    a = Atan(y/x);
  }else if(x < 0 && y >= 0){
    a = Atan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = Atan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function Squareroot(x){
  return Math.sqrt(x);
}
function Exp(x){
  return Math.exp(x);
}
function DivisibleBy(a, b){
  return ((a%b) == 0);
}
function Combinations(n, k){
  var i, j, c;

  c = 1;
  j = 1;
  i = n - k + 1;

  for(; i <= n; ){
    c = c*i;
    c = c/j;

    i = i + 1;
    j = j + 1;
  }

  return c;
}
function Permutations(n, k){
  var i, c;

  c = 1;

  for(i = n - k + 1; i <= n; i = i + 1){
    c = c*i;
  }

  return c;
}
function EpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function GreatestCommonDivisor(a, b){
  var t;

  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function GCDWithSubtraction(a, b){
  var g;

  if(a == 0){
    g = b;
  }else{
    for(; b != 0; ){
      if(a > b){
        a = a - b;
      }else{
        b = b - a;
      }
    }

    g = a;
  }

  return g;
}
function IsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function GreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;

  if(IsInteger(a) && IsInteger(b)){
    gcd = GreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultiple(a, b){
  var lcm;

  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/GreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function Sign(a){
  var s;

  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function Max(a, b){
  return Math.max(a, b);
}
function Min(a, b){
  return Math.min(a, b);
}
function Power(a, b){
  return Math.pow(a, b);
}
function Gamma(x){
  return LanczosApproximation(x);
}
function LogGamma(x){
  return Math.log(Gamma(x));
}
function LanczosApproximation(z){
  var p;
  var i, y, t, x;

  p = [];
  p.length = 8;
  p[0] = 676.5203681218851;
  p[1] =  -1259.1392167224028;
  p[2] = 771.32342877765313;
  p[3] =  -176.61502916214059;
  p[4] = 12.507343278686905;
  p[5] =  -0.13857109526572012;
  p[6] = 9.9843695780195716e-6;
  p[7] = 1.5056327351493116e-7;

  if(z < 0.5){
    y = Math.PI/(Math.sin(Math.PI*z)*LanczosApproximation(1 - z));
  }else{
    z = z - 1;
    x = 0.99999999999980993;
    for(i = 0; i < p.length; i = i + 1){
      x = x + p[i]/(z + i + 1);
    }
    t = z + p.length - 0.5;
    y = Math.sqrt(2*Math.PI)*Math.pow(t, z + 0.5)*Math.exp( -t)*x;
  }

  return y;
}
function Beta(x, y){
  return Gamma(x)*Gamma(y)/Gamma(x + y);
}
function Sinh(x){
  return (Math.exp(x) - Math.exp( -x))/2;
}
function Cosh(x){
  return (Math.exp(x) + Math.exp( -x))/2;
}
function Tanh(x){
  return Sinh(x)/Cosh(x);
}
function Cot(x){
  return 1/Math.tan(x);
}
function Sec(x){
  return 1/Math.cos(x);
}
function Csc(x){
  return 1/Math.sin(x);
}
function Coth(x){
  return Cosh(x)/Sinh(x);
}
function Sech(x){
  return 1/Cosh(x);
}
function Csch(x){
  return 1/Sinh(x);
}
function Error(x){
  var y, t, tau, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10;

  if(x == 0){
    y = 0;
  }else if(x < 0){
    y =  -Error( -x);
  }else{
    c1 =  -1.26551223;
    c2 =  +1.00002368;
    c3 =  +0.37409196;
    c4 =  +0.09678418;
    c5 =  -0.18628806;
    c6 =  +0.27886807;
    c7 =  -1.13520398;
    c8 =  +1.48851587;
    c9 =  -0.82215223;
    c10 =  +0.17087277;

    t = 1/(1 + 0.5*Math.abs(x));

    tau = t*Math.exp( -(Math.pow(x, 2)) + c1 + t*(c2 + t*(c3 + t*(c4 + t*(c5 + t*(c6 + t*(c7 + t*(c8 + t*(c9 + t*c10)))))))));

    y = 1 - tau;
  }

  return y;
}
function ErrorInverse(x){
  var y, a, t;

  a = (8*(Math.PI - 3))/(3*Math.PI*(4 - Math.PI));

  t = 2/(Math.PI*a) + Math.log(1 - Math.pow(x, 2))/2;
  y = Sign(x)*Math.sqrt(Math.sqrt(Math.pow(t, 2) - Math.log(1 - Math.pow(x, 2))/a) - t);

  return y;
}
function FallingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x - k);
  }

  return y;
}
function RisingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x + k);
  }

  return y;
}
function Hypergeometric(a, b, c, z, maxIterations, precision){
  var y;

  if(Math.abs(z) >= 0.5){
    y = Math.pow(1 - z,  -a)*HypergeometricDirect(a, c - b, c, z/(z - 1), maxIterations, precision);
  }else{
    y = HypergeometricDirect(a, b, c, z, maxIterations, precision);
  }

  return y;
}
function HypergeometricDirect(a, b, c, z, maxIterations, precision){
  var y, yp, n;
  var done;

  y = 0;
  done = false;

  for(n = 0; n < maxIterations &&  !done ; n = n + 1){
    yp = RisingFactorial(a, n)*RisingFactorial(b, n)/RisingFactorial(c, n)*Math.pow(z, n)/Factorial(n);
    if(Math.abs(yp) < precision){
      done = true;
    }
    y = y + yp;
  }

  return y;
}
function BernouilliNumber(n){
  return AkiyamaTanigawaAlgorithm(n);
}
function AkiyamaTanigawaAlgorithm(n){
  var m, j, B;
  var A;

  A = [];
  A.length = n + 1;

  for(m = 0; m <= n; m = m + 1){
    A[m] = 1/(m + 1);
    for(j = m; j >= 1; j = j - 1){
      A[j - 1] = j*(A[j - 1] - A[j]);
    }
  }

  B = A[0];

  delete(A);

  return B;
}
function CreateStringScientificNotationDecimalFromNumber(decimal){
  return CreateStringScientificNotationDecimalFromNumberAllOptions(decimal, false);
}
function CreateStringScientificNotationDecimalFromNumber15d2e(decimal){
  return CreateStringScientificNotationDecimalFromNumberAllOptions(decimal, true);
}
function CreateStringScientificNotationDecimalFromNumberAllOptions(decimal, complete){
  var mantissaReference, exponentReference;
  var multiplier, inc, i, additional;
  var exponent;
  var done, isPositive, isPositiveExponent;
  var result;

  mantissaReference = {};
  exponentReference = {};
  result = [];
  result.length = 0;
  done = false;
  exponent = 0;

  if(decimal < 0){
    isPositive = false;
    decimal =  -decimal;
  }else{
    isPositive = true;
  }

  if(decimal == 0){
    done = true;
  }

  if( !done ){
    multiplier = 0;
    inc = 0;

    if(decimal < 1){
      multiplier = 10;
      inc =  -1;
    }else if(decimal >= 10){
      multiplier = 0.1;
      inc = 1;
    }else{
      done = true;
    }

    if( !done ){
      exponent = Math.round(Math.log10(decimal));
      exponent = Math.min(99, exponent);
      exponent = Math.max( -99, exponent);

      decimal = decimal/Math.pow(10, exponent);

      /* Adjust */
      for(; (decimal >= 10 || decimal < 1) && Math.abs(exponent) < 99; ){
        decimal = decimal*multiplier;
        exponent = exponent + inc;
      }
    }
  }

  CreateStringFromNumberWithCheck(decimal, 10, mantissaReference);

  isPositiveExponent = exponent >= 0;
  if( !isPositiveExponent ){
    exponent =  -exponent;
  }

  CreateStringFromNumberWithCheck(exponent, 10, exponentReference);

  if( !isPositive ){
    result = AppendString(result, "-".split(''));
  }else if(complete){
    result = AppendString(result, "+".split(''));
  }

  result = AppendString(result, mantissaReference.string);
  if(complete){
    additional = 16;

    if(mantissaReference.string.length == 1){
      result = AppendString(result, ".".split(''));
      additional = additional - 1;
    }

    for(i = mantissaReference.string.length; i < additional; i = i + 1){
      result = AppendString(result, "0".split(''));
    }
  }
  result = AppendString(result, "e".split(''));

  if( !isPositiveExponent ){
    result = AppendString(result, "-".split(''));
  }else if(complete){
    result = AppendString(result, "+".split(''));
  }

  if(complete){
    for(i = exponentReference.string.length; i < 2; i = i + 1){
      result = AppendString(result, "0".split(''));
    }
  }
  result = AppendString(result, exponentReference.string);

  return result;
}
function CreateStringDecimalFromNumber(decimal){
  var stringReference;

  stringReference = {};

  /* This will succeed because base = 10. */
  CreateStringFromNumberWithCheck(decimal, 10, stringReference);

  return stringReference.string;
}
function CreateStringFromNumberWithCheck(decimal, base, stringReference){
  var string;
  var maximumDigits;
  var digitPosition;
  var hasPrintedPoint, isPositive;
  var i, d;
  var success;
  var characterReference;
  var c;

  isPositive = true;

  if(decimal < 0){
    isPositive = false;
    decimal =  -decimal;
  }

  if(decimal == 0){
    stringReference.string = "0".split('');
    success = true;
  }else{
    characterReference = {};

    if(IsInteger(base)){
      success = true;

      string = [];
      string.length = 0;

      maximumDigits = GetMaximumDigitsForBase(base);

      digitPosition = GetFirstDigitPosition(decimal, base);

      decimal = Math.round(decimal*Math.pow(base, maximumDigits - digitPosition - 1));

      hasPrintedPoint = false;

      if( !isPositive ){
        string = AppendCharacter(string, '-');
      }

      /* Print leading zeros. */
      if(digitPosition < 0){
        string = AppendCharacter(string, '0');
        string = AppendCharacter(string, '.');
        hasPrintedPoint = true;
        for(i = 0; i <  -digitPosition - 1; i = i + 1){
          string = AppendCharacter(string, '0');
        }
      }

      /* Print number. */
      for(i = 0; i < maximumDigits && success; i = i + 1){
        d = Math.floor(decimal/Math.pow(base, maximumDigits - i - 1));

        if(d >= base){
          d = base - 1;
        }

        if( !hasPrintedPoint  && digitPosition - i + 1 == 0){
          if(decimal != 0){
            string = AppendCharacter(string, '.');
          }
          hasPrintedPoint = true;
        }

        if(decimal == 0 && hasPrintedPoint){
        }else{
          success = GetSingleDigitCharacterFromNumberWithCheck(d, base, characterReference);
          if(success){
            c = characterReference.characterValue;
            string = AppendCharacter(string, c);
          }
        }

        if(success){
          decimal = decimal - d*Math.pow(base, maximumDigits - i - 1);
        }
      }

      if(success){
        /* Print trailing zeros. */
        for(i = 0; i < digitPosition - maximumDigits + 1; i = i + 1){
          string = AppendCharacter(string, '0');
        }

        stringReference.string = string;
      }
    }else{
      success = false;
    }
  }

  /* Done */
  return success;
}
function GetMaximumDigitsForBase(base){
  var t;

  t = Math.pow(10, 15);
  return Math.floor(Math.log10(t)/Math.log10(base));
}
function GetFirstDigitPosition(decimal, base){
  var power;
  var t;

  power = Math.ceil(Math.log10(decimal)/Math.log10(base));

  t = decimal*Math.pow(base,  -power);
  if(t < base && t >= 1){
  }else if(t >= base){
    power = power + 1;
  }else if(t < 1){
    power = power - 1;
  }

  return power;
}
function GetSingleDigitCharacterFromNumberWithCheck(c, base, characterReference){
  var numberTable;
  var success;

  numberTable = GetDigitCharacterTable();

  if(c < base || c < numberTable.length){
    success = true;
    characterReference.characterValue = numberTable[c];
  }else{
    success = false;
  }

  return success;
}
function GetDigitCharacterTable(){
  var numberTable;

  numberTable = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".split('');

  return numberTable;
}
function CreateNumberFromDecimalStringWithCheck(string, decimalReference, errorMessage){
  return CreateNumberFromStringWithCheck(string, 10, decimalReference, errorMessage);
}
function CreateNumberFromDecimalString(string){
  var doubleReference;
  var stringReference;
  var number;

  doubleReference = CreateNumberReference(0);
  stringReference = CreateStringReference("".split(''));
  CreateNumberFromStringWithCheck(string, 10, doubleReference, stringReference);
  number = doubleReference.numberValue;

  delete(doubleReference);
  delete(stringReference);

  return number;
}
function CreateNumberFromStringWithCheck(string, base, numberReference, errorMessage){
  var success;
  var numberIsPositive, exponentIsPositive;
  var beforePoint, afterPoint, exponent;

  numberIsPositive = CreateBooleanReference(true);
  exponentIsPositive = CreateBooleanReference(true);
  beforePoint = {};
  afterPoint = {};
  exponent = {};

  if(base >= 2 && base <= 36){
    success = ExtractPartsFromNumberString(string, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessage);

    if(success){
      numberReference.numberValue = CreateNumberFromParts(base, numberIsPositive.booleanValue, beforePoint.numberArray, afterPoint.numberArray, exponentIsPositive.booleanValue, exponent.numberArray);
    }
  }else{
    success = false;
    errorMessage.string = "Base must be from 2 to 36.".split('');
  }

  return success;
}
function CreateNumberFromParts(base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent){
  var n, i, p, e;

  n = 0;

  for(i = 0; i < beforePoint.length; i = i + 1){
    p = beforePoint[beforePoint.length - i - 1];

    n = n + p*Math.pow(base, i);
  }

  for(i = 0; i < afterPoint.length; i = i + 1){
    p = afterPoint[i];

    n = n + p*Math.pow(base,  -(i + 1));
  }

  if(exponent.length > 0){
    e = 0;
    for(i = 0; i < exponent.length; i = i + 1){
      p = exponent[exponent.length - i - 1];

      e = e + p*Math.pow(base, i);
    }

    if( !exponentIsPositive ){
      e =  -e;
    }

    n = n*Math.pow(base, e);
  }

  if( !numberIsPositive ){
    n =  -n;
  }

  return n;
}
function ExtractPartsFromNumberString(n, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages){
  var i;
  var success;

  i = 0;

  if(i < n.length){
    if(n[i] == '-'){
      numberIsPositive.booleanValue = false;
      i = i + 1;
    }else if(n[i] == '+'){
      numberIsPositive.booleanValue = true;
      i = i + 1;
    }

    success = ExtractPartsFromNumberStringFromSign(n, base, i, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages);
  }else{
    success = false;
    errorMessages.string = "Number cannot have length zero.".split('');
  }

  return success;
}
function ExtractPartsFromNumberStringFromSign(n, base, i, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages){
  var success, done;
  var count, j;

  done = false;
  count = 0;
  for(; i + count < n.length &&  !done ; ){
    if(CharacterIsNumberCharacterInBase(n[i + count], base)){
      count = count + 1;
    }else{
      done = true;
    }
  }

  if(count >= 1){
    beforePoint.numberArray = [];
    beforePoint.numberArray.length = count;

    for(j = 0; j < count; j = j + 1){
      beforePoint.numberArray[j] = GetNumberFromNumberCharacterForBase(n[i + j], base);
    }

    i = i + count;

    if(i < n.length){
      success = ExtractPartsFromNumberStringFromPointOrExponent(n, base, i, afterPoint, exponentIsPositive, exponent, errorMessages);
    }else{
      afterPoint.numberArray = [];
      afterPoint.numberArray.length = 0;
      exponent.numberArray = [];
      exponent.numberArray.length = 0;
      success = true;
    }
  }else{
    success = false;
    errorMessages.string = "Number must have at least one number after the optional sign.".split('');
  }

  return success;
}
function ExtractPartsFromNumberStringFromPointOrExponent(n, base, i, afterPoint, exponentIsPositive, exponent, errorMessages){
  var success, done;
  var count, j;

  if(n[i] == '.'){
    i = i + 1;

    if(i < n.length){
      done = false;
      count = 0;
      for(; i + count < n.length &&  !done ; ){
        if(CharacterIsNumberCharacterInBase(n[i + count], base)){
          count = count + 1;
        }else{
          done = true;
        }
      }

      if(count >= 1){
        afterPoint.numberArray = [];
        afterPoint.numberArray.length = count;

        for(j = 0; j < count; j = j + 1){
          afterPoint.numberArray[j] = GetNumberFromNumberCharacterForBase(n[i + j], base);
        }

        i = i + count;

        if(i < n.length){
          success = ExtractPartsFromNumberStringFromExponent(n, base, i, exponentIsPositive, exponent, errorMessages);
        }else{
          exponent.numberArray = [];
          exponent.numberArray.length = 0;
          success = true;
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the decimal point.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "There must be at least one digit after the decimal point.".split('');
    }
  }else if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
    if(i < n.length){
      success = ExtractPartsFromNumberStringFromExponent(n, base, i, exponentIsPositive, exponent, errorMessages);
      afterPoint.numberArray = [];
      afterPoint.numberArray.length = 0;
    }else{
      success = false;
      errorMessages.string = "There must be at least one digit after the exponent.".split('');
    }
  }else{
    success = false;
    errorMessages.string = "Expected decimal point or exponent symbol.".split('');
  }

  return success;
}
function ExtractPartsFromNumberStringFromExponent(n, base, i, exponentIsPositive, exponent, errorMessages){
  var success, done;
  var count, j;

  if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
    i = i + 1;

    if(i < n.length){
      if(n[i] == '-'){
        exponentIsPositive.booleanValue = false;
        i = i + 1;
      }else if(n[i] == '+'){
        exponentIsPositive.booleanValue = true;
        i = i + 1;
      }

      if(i < n.length){
        done = false;
        count = 0;
        for(; i + count < n.length &&  !done ; ){
          if(CharacterIsNumberCharacterInBase(n[i + count], base)){
            count = count + 1;
          }else{
            done = true;
          }
        }

        if(count >= 1){
          exponent.numberArray = [];
          exponent.numberArray.length = count;

          for(j = 0; j < count; j = j + 1){
            exponent.numberArray[j] = GetNumberFromNumberCharacterForBase(n[i + j], base);
          }

          i = i + count;

          if(i == n.length){
            success = true;
          }else{
            success = false;
            errorMessages.string = "There cannot be any characters past the exponent of the number.".split('');
          }
        }else{
          success = false;
          errorMessages.string = "There must be at least one digit after the decimal point.".split('');
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
    }
  }else{
    success = false;
    errorMessages.string = "Expected exponent symbol.".split('');
  }

  return success;
}
function GetNumberFromNumberCharacterForBase(c, base){
  var numberTable;
  var i;
  var position;

  numberTable = GetDigitCharacterTable();
  position = 0;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      position = i;
    }
  }

  return position;
}
function CharacterIsNumberCharacterInBase(c, base){
  var numberTable;
  var i;
  var found;

  numberTable = GetDigitCharacterTable();
  found = false;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      found = true;
    }
  }

  return found;
}
function StringToNumberArray(str){
  var numberArrayReference;
  var stringReference;
  var numbers;

  numberArrayReference = {};
  stringReference = {};

  StringToNumberArrayWithCheck(str, numberArrayReference, stringReference);

  numbers = numberArrayReference.numberArray;

  delete(numberArrayReference);
  delete(stringReference);

  return numbers;
}
function StringToNumberArrayWithCheck(str, numberArrayReference, errorMessage){
  var numberStrings;
  var numbers;
  var i;
  var numberString, trimmedNumberString;
  var success;
  var numberReference;

  numberStrings = SplitByString(str, ",".split(''));

  numbers = [];
  numbers.length = numberStrings.length;
  success = true;
  numberReference = {};

  for(i = 0; i < numberStrings.length; i = i + 1){
    numberString = numberStrings[i].string;
    trimmedNumberString = Trim(numberString);
    success = CreateNumberFromDecimalStringWithCheck(trimmedNumberString, numberReference, errorMessage);
    numbers[i] = numberReference.numberValue;

    FreeStringReference(numberStrings[i]);
    delete(trimmedNumberString);
  }

  delete(numberStrings);
  delete(numberReference);

  numberArrayReference.numberArray = numbers;

  return success;
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !arraysStringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function WriteStringToStingStream(stream, index, src){
  var i;

  for(i = 0; i < src.length; i = i + 1){
    stream[index.numberValue + i] = src[i];
  }
  index.numberValue = index.numberValue + src.length;
}
function WriteCharacterToStingStream(stream, index, src){
  stream[index.numberValue] = src;
  index.numberValue = index.numberValue + 1;
}
function WriteBooleanToStingStream(stream, index, src){
  if(src){
    WriteStringToStingStream(stream, index, "true".split(''));
  }else{
    WriteStringToStingStream(stream, index, "false".split(''));
  }
}
function SubstringWithCheck(string, from, to, stringReference){
  var success;

  if(from >= 0 && from <= string.length && to >= 0 && to <= string.length && from <= to){
    stringReference.string = Substring(string, from, to);
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Substring(string, from, to){
  var n;
  var i, lengthx;

  lengthx = to - from;

  n = [];
  n.length = lengthx;

  for(i = from; i < to; i = i + 1){
    n[i - from] = string[i];
  }

  return n;
}
function AppendString(s1, s2){
  var newString;

  newString = ConcatenateString(s1, s2);

  delete(s1);

  return newString;
}
function ConcatenateString(s1, s2){
  var newString;
  var i;

  newString = [];
  newString.length = s1.length + s2.length;

  for(i = 0; i < s1.length; i = i + 1){
    newString[i] = s1[i];
  }

  for(i = 0; i < s2.length; i = i + 1){
    newString[s1.length + i] = s2[i];
  }

  return newString;
}
function AppendCharacter(string, c){
  var newString;

  newString = ConcatenateCharacter(string, c);

  delete(string);

  return newString;
}
function ConcatenateCharacter(string, c){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + 1;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  newString[string.length] = c;

  return newString;
}
function SplitByCharacter(toSplit, splitBy){
  var split;
  var stringToSplitBy;

  stringToSplitBy = [];
  stringToSplitBy.length = 1;
  stringToSplitBy[0] = splitBy;

  split = SplitByString(toSplit, stringToSplitBy);

  delete(stringToSplitBy);

  return split;
}
function IndexOfCharacter(string, character, indexReference){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function SubstringEqualsWithCheck(string, from, substring, equalsReference){
  var success;

  if(from < string.length){
    success = true;
    equalsReference.booleanValue = SubstringEquals(string, from, substring);
  }else{
    success = false;
  }

  return success;
}
function SubstringEquals(string, from, substring){
  var i;
  var equal;

  equal = true;
  if(string.length - from >= substring.length){
    for(i = 0; i < substring.length && equal; i = i + 1){
      if(string[from + i] != substring[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function IndexOfString(string, substring, indexReference){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length - substring.length + 1 &&  !found ; i = i + 1){
    if(SubstringEquals(string, i, substring)){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function ContainsCharacter(string, character){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
    }
  }

  return found;
}
function ContainsString(string, substring){
  return IndexOfString(string, substring, {});
}
function ToUpperCase(string){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToUpperCase(string[i]);
  }
}
function ToLowerCase(string){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToLowerCase(string[i]);
  }
}
function EqualsIgnoreCase(a, b){
  var equal;
  var i;

  if(a.length == b.length){
    equal = true;
    for(i = 0; i < a.length && equal; i = i + 1){
      if(charToLowerCase(a[i]) != charToLowerCase(b[i])){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function ReplaceString(string, toReplace, replaceWith){
  var result;
  var i;
  var equalsReference;
  var success;

  equalsReference = {};
  result = [];
  result.length = 0;

  for(i = 0; i < string.length; ){
    success = SubstringEqualsWithCheck(string, i, toReplace, equalsReference);
    if(success){
      success = equalsReference.booleanValue;
    }

    if(success && toReplace.length > 0){
      result = ConcatenateString(result, replaceWith);
      i = i + toReplace.length;
    }else{
      result = ConcatenateCharacter(result, string[i]);
      i = i + 1;
    }
  }

  return result;
}
function ReplaceCharacter(string, toReplace, replaceWith){
  var result;
  var i;

  result = [];
  result.length = 0;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      result = ConcatenateCharacter(result, replaceWith);
    }else{
      result = ConcatenateCharacter(result, string[i]);
    }
  }

  return result;
}
function Trim(string){
  var result;
  var i, lastWhitespaceLocationStart, lastWhitespaceLocationEnd;
  var firstNonWhitespaceFound;

  /* Find whitepaces at the start. */
  lastWhitespaceLocationStart =  -1;
  firstNonWhitespaceFound = false;
  for(i = 0; i < string.length &&  !firstNonWhitespaceFound ; i = i + 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationStart = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  /* Find whitepaces at the end. */
  lastWhitespaceLocationEnd = string.length;
  firstNonWhitespaceFound = false;
  for(i = string.length - 1; i >= 0 &&  !firstNonWhitespaceFound ; i = i - 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationEnd = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  if(lastWhitespaceLocationStart < lastWhitespaceLocationEnd){
    result = Substring(string, lastWhitespaceLocationStart + 1, lastWhitespaceLocationEnd);
  }else{
    result = [];
    result.length = 0;
  }

  return result;
}
function StartsWith(string, start){
  var startsWithString;

  startsWithString = false;
  if(string.length >= start.length){
    startsWithString = SubstringEquals(string, 0, start);
  }

  return startsWithString;
}
function EndsWith(string, end){
  var endsWithString;

  endsWithString = false;
  if(string.length >= end.length){
    endsWithString = SubstringEquals(string, string.length - end.length, end);
  }

  return endsWithString;
}
function SplitByString(toSplit, splitBy){
  var split;
  var next;
  var i;
  var c;
  var n;

  split = [];
  split.length = 0;

  next = [];
  next.length = 0;
  for(i = 0; i < toSplit.length; ){
    c = toSplit[i];

    if(SubstringEquals(toSplit, i, splitBy)){
      n = {};
      n.string = next;
      split = AddString(split, n);
      next = [];
      next.length = 0;
      i = i + splitBy.length;
    }else{
      next = AppendCharacter(next, c);
      i = i + 1;
    }
  }

  n = {};
  n.string = next;
  split = AddString(split, n);

  return split;
}
function StringIsBefore(a, b){
  var before, equal, done;
  var i;

  before = false;
  equal = true;
  done = false;

  if(a.length == 0 && b.length > 0){
    before = true;
  }else{
    for(i = 0; i < a.length && i < b.length &&  !done ; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
      if(charCharacterIsBefore(a[i], b[i])){
        before = true;
      }
      if(charCharacterIsBefore(b[i], a[i])){
        done = true;
      }
    }

    if(equal){
      if(a.length < b.length){
        before = true;
      }
    }
  }

  return before;
}
function arraysStringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function arraysNumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function arraysNumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysBooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysStringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysFillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysFillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysFillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysIsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function arraysCreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  arraysFillNumberArray(array, value);

  return array;
}
function arraysCreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  arraysFillBooleanArray(array, value);

  return array;
}
function arraysCreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  arraysFillString(array, value);

  return array;
}
function arraysSwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function arraysSwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function arraysReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    arraysSwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function AddNumber(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function AddBoolean(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function CreateLinkedListString(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddString(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListStringsToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListStringsLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = {};
    array[i].string = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListStringsLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListString(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function CreateLinkedListNumbers(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function CreateLinkedListNumbersArray(lengthx){
  var lls;
  var i;

  lls = [];
  lls.length = lengthx;
  for(i = 0; i < lls.length; i = i + 1){
    lls[i] = CreateLinkedListNumbers();
  }

  return lls;
}
function LinkedListAddNumber(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListNumbersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function LinkedListNumbersIndex(ll, index){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  return node.value;
}
function LinkedListInsertNumber(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function LinkedListSet(ll, index, value){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  node.next.value = value;
}
function LinkedListRemoveNumber(ll, index){
  var i;
  var node, prev;

  node = ll.first;
  prev = ll.first;

  for(i = 0; i < index; i = i + 1){
    prev = node;
    node = node.next;
  }

  if(index == 0){
    ll.first = prev.next;
  }
  if( !prev.next.end ){
    prev.next = prev.next.next;
  }
}
function FreeLinkedListNumbers(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function FreeLinkedListNumbersArray(lls){
  var i;

  for(i = 0; i < lls.length; i = i + 1){
    FreeLinkedListNumbers(lls[i]);
  }
  delete(lls);
}
function LinkedListNumbersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListNumbersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function ArrayToLinkedListNumbers(array){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < array.length; i = i + 1){
    LinkedListAddNumber(ll, array[i]);
  }

  return ll;
}
function LinkedListNumbersEqual(a, b){
  var equal, done;
  var an, bn;

  an = a.first;
  bn = b.first;

  equal = true;
  done = false;
  for(; equal &&  !done ; ){
    if(an.end == bn.end){
      if(an.end){
        done = true;
      }else if(an.value == bn.value){
        an = an.next;
        bn = bn.next;
      }else{
        equal = false;
      }
    }else{
      equal = false;
    }
  }

  return equal;
}
function CreateLinkedListCharacter(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddCharacter(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListCharactersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListCharactersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListCharactersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListCharacter(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function CreateDynamicArrayNumbers(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayNumbersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddNumber(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumbersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayNumbersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersIndex(da, index){
  return da.array[index];
}
function DynamicArrayNumbersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertNumber(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArraySet(da, index, value){
  da.array[index] = value;
}
function DynamicArrayRemoveNumber(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayNumbersDecreaseSizeNecessary(da)){
    DynamicArrayNumbersDecreaseSize(da);
  }
}
function FreeDynamicArrayNumbers(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayNumbersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayNumbersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  /*
         c = 10*(3/2)^n
         log(c) = log(10*(3/2)^n)
         log(c) = log(10) + log((3/2)^n)
         log(c) = 1 + log((3/2)^n)
         log(c) - 1 = log((3/2)^n)
         log(c) - 1 = n*log(3/2)
         n = (log(c) - 1)/log(3/2)
         */
  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.floor(n) + 1;

  da = CreateDynamicArrayNumbersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayNumbers(array){
  var da;

  da = {};
  da.array = arraysCopyNumberArray(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayNumbersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayNumbersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddNumber(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayNumbers(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListNumbersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function AddCharacter(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}
function charToLowerCase(character){
  var toReturn;

  toReturn = character;
  if(character == 'A'){
    toReturn = 'a';
  }else if(character == 'B'){
    toReturn = 'b';
  }else if(character == 'C'){
    toReturn = 'c';
  }else if(character == 'D'){
    toReturn = 'd';
  }else if(character == 'E'){
    toReturn = 'e';
  }else if(character == 'F'){
    toReturn = 'f';
  }else if(character == 'G'){
    toReturn = 'g';
  }else if(character == 'H'){
    toReturn = 'h';
  }else if(character == 'I'){
    toReturn = 'i';
  }else if(character == 'J'){
    toReturn = 'j';
  }else if(character == 'K'){
    toReturn = 'k';
  }else if(character == 'L'){
    toReturn = 'l';
  }else if(character == 'M'){
    toReturn = 'm';
  }else if(character == 'N'){
    toReturn = 'n';
  }else if(character == 'O'){
    toReturn = 'o';
  }else if(character == 'P'){
    toReturn = 'p';
  }else if(character == 'Q'){
    toReturn = 'q';
  }else if(character == 'R'){
    toReturn = 'r';
  }else if(character == 'S'){
    toReturn = 's';
  }else if(character == 'T'){
    toReturn = 't';
  }else if(character == 'U'){
    toReturn = 'u';
  }else if(character == 'V'){
    toReturn = 'v';
  }else if(character == 'W'){
    toReturn = 'w';
  }else if(character == 'X'){
    toReturn = 'x';
  }else if(character == 'Y'){
    toReturn = 'y';
  }else if(character == 'Z'){
    toReturn = 'z';
  }

  return toReturn;
}
function charToUpperCase(character){
  var toReturn;

  toReturn = character;
  if(character == 'a'){
    toReturn = 'A';
  }else if(character == 'b'){
    toReturn = 'B';
  }else if(character == 'c'){
    toReturn = 'C';
  }else if(character == 'd'){
    toReturn = 'D';
  }else if(character == 'e'){
    toReturn = 'E';
  }else if(character == 'f'){
    toReturn = 'F';
  }else if(character == 'g'){
    toReturn = 'G';
  }else if(character == 'h'){
    toReturn = 'H';
  }else if(character == 'i'){
    toReturn = 'I';
  }else if(character == 'j'){
    toReturn = 'J';
  }else if(character == 'k'){
    toReturn = 'K';
  }else if(character == 'l'){
    toReturn = 'L';
  }else if(character == 'm'){
    toReturn = 'M';
  }else if(character == 'n'){
    toReturn = 'N';
  }else if(character == 'o'){
    toReturn = 'O';
  }else if(character == 'p'){
    toReturn = 'P';
  }else if(character == 'q'){
    toReturn = 'Q';
  }else if(character == 'r'){
    toReturn = 'R';
  }else if(character == 's'){
    toReturn = 'S';
  }else if(character == 't'){
    toReturn = 'T';
  }else if(character == 'u'){
    toReturn = 'U';
  }else if(character == 'v'){
    toReturn = 'V';
  }else if(character == 'w'){
    toReturn = 'W';
  }else if(character == 'x'){
    toReturn = 'X';
  }else if(character == 'y'){
    toReturn = 'Y';
  }else if(character == 'z'){
    toReturn = 'Z';
  }

  return toReturn;
}
function charIsUpperCase(character){
  var isUpper;

  isUpper = false;
  if(character == 'A'){
    isUpper = true;
  }else if(character == 'B'){
    isUpper = true;
  }else if(character == 'C'){
    isUpper = true;
  }else if(character == 'D'){
    isUpper = true;
  }else if(character == 'E'){
    isUpper = true;
  }else if(character == 'F'){
    isUpper = true;
  }else if(character == 'G'){
    isUpper = true;
  }else if(character == 'H'){
    isUpper = true;
  }else if(character == 'I'){
    isUpper = true;
  }else if(character == 'J'){
    isUpper = true;
  }else if(character == 'K'){
    isUpper = true;
  }else if(character == 'L'){
    isUpper = true;
  }else if(character == 'M'){
    isUpper = true;
  }else if(character == 'N'){
    isUpper = true;
  }else if(character == 'O'){
    isUpper = true;
  }else if(character == 'P'){
    isUpper = true;
  }else if(character == 'Q'){
    isUpper = true;
  }else if(character == 'R'){
    isUpper = true;
  }else if(character == 'S'){
    isUpper = true;
  }else if(character == 'T'){
    isUpper = true;
  }else if(character == 'U'){
    isUpper = true;
  }else if(character == 'V'){
    isUpper = true;
  }else if(character == 'W'){
    isUpper = true;
  }else if(character == 'X'){
    isUpper = true;
  }else if(character == 'Y'){
    isUpper = true;
  }else if(character == 'Z'){
    isUpper = true;
  }

  return isUpper;
}
function charIsLowerCase(character){
  var isLower;

  isLower = false;
  if(character == 'a'){
    isLower = true;
  }else if(character == 'b'){
    isLower = true;
  }else if(character == 'c'){
    isLower = true;
  }else if(character == 'd'){
    isLower = true;
  }else if(character == 'e'){
    isLower = true;
  }else if(character == 'f'){
    isLower = true;
  }else if(character == 'g'){
    isLower = true;
  }else if(character == 'h'){
    isLower = true;
  }else if(character == 'i'){
    isLower = true;
  }else if(character == 'j'){
    isLower = true;
  }else if(character == 'k'){
    isLower = true;
  }else if(character == 'l'){
    isLower = true;
  }else if(character == 'm'){
    isLower = true;
  }else if(character == 'n'){
    isLower = true;
  }else if(character == 'o'){
    isLower = true;
  }else if(character == 'p'){
    isLower = true;
  }else if(character == 'q'){
    isLower = true;
  }else if(character == 'r'){
    isLower = true;
  }else if(character == 's'){
    isLower = true;
  }else if(character == 't'){
    isLower = true;
  }else if(character == 'u'){
    isLower = true;
  }else if(character == 'v'){
    isLower = true;
  }else if(character == 'w'){
    isLower = true;
  }else if(character == 'x'){
    isLower = true;
  }else if(character == 'y'){
    isLower = true;
  }else if(character == 'z'){
    isLower = true;
  }

  return isLower;
}
function charIsLetter(character){
  return charIsUpperCase(character) || charIsLowerCase(character);
}
function charIsNumber(character){
  var isNumberx;

  isNumberx = false;
  if(character == '0'){
    isNumberx = true;
  }else if(character == '1'){
    isNumberx = true;
  }else if(character == '2'){
    isNumberx = true;
  }else if(character == '3'){
    isNumberx = true;
  }else if(character == '4'){
    isNumberx = true;
  }else if(character == '5'){
    isNumberx = true;
  }else if(character == '6'){
    isNumberx = true;
  }else if(character == '7'){
    isNumberx = true;
  }else if(character == '8'){
    isNumberx = true;
  }else if(character == '9'){
    isNumberx = true;
  }

  return isNumberx;
}
function charIsWhiteSpace(character){
  var isWhiteSpacex;

  isWhiteSpacex = false;
  if(character == ' '){
    isWhiteSpacex = true;
  }else if(character == '\t'){
    isWhiteSpacex = true;
  }else if(character == '\n'){
    isWhiteSpacex = true;
  }else if(character == '\r'){
    isWhiteSpacex = true;
  }

  return isWhiteSpacex;
}
function charIsSymbol(character){
  var isSymbolx;

  isSymbolx = false;
  if(character == '!'){
    isSymbolx = true;
  }else if(character == '\"'){
    isSymbolx = true;
  }else if(character == '#'){
    isSymbolx = true;
  }else if(character == '$'){
    isSymbolx = true;
  }else if(character == '%'){
    isSymbolx = true;
  }else if(character == '&'){
    isSymbolx = true;
  }else if(character == '\''){
    isSymbolx = true;
  }else if(character == '('){
    isSymbolx = true;
  }else if(character == ')'){
    isSymbolx = true;
  }else if(character == '*'){
    isSymbolx = true;
  }else if(character == '+'){
    isSymbolx = true;
  }else if(character == ','){
    isSymbolx = true;
  }else if(character == '-'){
    isSymbolx = true;
  }else if(character == '.'){
    isSymbolx = true;
  }else if(character == '/'){
    isSymbolx = true;
  }else if(character == ':'){
    isSymbolx = true;
  }else if(character == ';'){
    isSymbolx = true;
  }else if(character == '<'){
    isSymbolx = true;
  }else if(character == '='){
    isSymbolx = true;
  }else if(character == '>'){
    isSymbolx = true;
  }else if(character == '?'){
    isSymbolx = true;
  }else if(character == '@'){
    isSymbolx = true;
  }else if(character == '['){
    isSymbolx = true;
  }else if(character == '\\'){
    isSymbolx = true;
  }else if(character == ']'){
    isSymbolx = true;
  }else if(character == '^'){
    isSymbolx = true;
  }else if(character == '_'){
    isSymbolx = true;
  }else if(character == '`'){
    isSymbolx = true;
  }else if(character == '{'){
    isSymbolx = true;
  }else if(character == '|'){
    isSymbolx = true;
  }else if(character == '}'){
    isSymbolx = true;
  }else if(character == '~'){
    isSymbolx = true;
  }

  return isSymbolx;
}
function charCharacterIsBefore(a, b){
  var ad, bd;

  ad = a.charCodeAt(0);
  bd = b.charCodeAt(0);

  return ad < bd;
}


module.exports = {
	Createu8: Createu8,
	Numberu8: Numberu8,
	Assignu8: Assignu8,
	U8IsValid: U8IsValid,
	WillOverflowu8: WillOverflowu8,
	ConvertToU8: ConvertToU8,
	ToStringu8: ToStringu8,
	ToHexStringu8: ToHexStringu8,
	Addu8: Addu8,
	AddIntou8: AddIntou8,
	Subtractu8: Subtractu8,
	SubtractIntou8: SubtractIntou8,
	Multiplyu8: Multiplyu8,
	MultiplyIntou8: MultiplyIntou8,
	Divideu8: Divideu8,
	DivideIntou8: DivideIntou8,
	Positiveu8: Positiveu8,
	Factorialu8: Factorialu8,
	Logarithmu8: Logarithmu8,
	NaturalLogarithmu8: NaturalLogarithmu8,
	Tanu8: Tanu8,
	Atan2_u8: Atan2_u8,
	Squarerootu8: Squarerootu8,
	Expu8: Expu8,
	DivisibleByu8: DivisibleByu8,
	Combinationsu8: Combinationsu8,
	Permutationsu8: Permutationsu8,
	EpsilonCompareu8: EpsilonCompareu8,
	GreatestCommonDivisoru8: GreatestCommonDivisoru8,
	GCDWithSubtractionu8: GCDWithSubtractionu8,
	LeastCommonMultipleu8: LeastCommonMultipleu8,
	Maxu8: Maxu8,
	Minu8: Minu8,
	Poweru8: Poweru8,
	Createu16: Createu16,
	Numberu16: Numberu16,
	Assignu16: Assignu16,
	u16IsValid: u16IsValid,
	WillOverflowu16: WillOverflowu16,
	ConvertToU16: ConvertToU16,
	ToStringu16: ToStringu16,
	ToHexStringu16: ToHexStringu16,
	Addu16: Addu16,
	AddIntou16: AddIntou16,
	Subtractu16: Subtractu16,
	SubtractIntou16: SubtractIntou16,
	Multiplyu16: Multiplyu16,
	MultiplyIntou16: MultiplyIntou16,
	Divideu16: Divideu16,
	DivideIntou16: DivideIntou16,
	Positiveu16: Positiveu16,
	Factorialu16: Factorialu16,
	Logarithmu16: Logarithmu16,
	NaturalLogarithmu16: NaturalLogarithmu16,
	Tanu16: Tanu16,
	Atan2_u16: Atan2_u16,
	Squarerootu16: Squarerootu16,
	Expu16: Expu16,
	DivisibleByu16: DivisibleByu16,
	Combinationsu16: Combinationsu16,
	Permutationsu16: Permutationsu16,
	EpsilonCompareu16: EpsilonCompareu16,
	GreatestCommonDivisoru16: GreatestCommonDivisoru16,
	GCDWithSubtractionu16: GCDWithSubtractionu16,
	LeastCommonMultipleu16: LeastCommonMultipleu16,
	Maxu16: Maxu16,
	Minu16: Minu16,
	Poweru16: Poweru16,
	Creates8: Creates8,
	ConvertToS8: ConvertToS8,
	ToStrings8: ToStrings8,
	ToHexStrings8: ToHexStrings8,
	Numbers8: Numbers8,
	Assigns8: Assigns8,
	S8IsValids8: S8IsValids8,
	WillOverflows8: WillOverflows8,
	Adds8: Adds8,
	AddIntos8: AddIntos8,
	Subtracts8: Subtracts8,
	SubtractIntos8: SubtractIntos8,
	Multiplys8: Multiplys8,
	MultiplyIntos8: MultiplyIntos8,
	Divides8: Divides8,
	DivideIntos8: DivideIntos8,
	Negates8: Negates8,
	Positives8: Positives8,
	Factorials8: Factorials8,
	Truncates8: Truncates8,
	Absolutes8: Absolutes8,
	Logarithms8: Logarithms8,
	NaturalLogarithms8: NaturalLogarithms8,
	Tans8: Tans8,
	Atans8: Atans8,
	Atan2_s8: Atan2_s8,
	Squareroots8: Squareroots8,
	Exps8: Exps8,
	DivisibleBys8: DivisibleBys8,
	Combinationss8: Combinationss8,
	Permutationss8: Permutationss8,
	EpsilonCompares8: EpsilonCompares8,
	GreatestCommonDivisors8: GreatestCommonDivisors8,
	GCDWithSubtractions8: GCDWithSubtractions8,
	IsIntegers8: IsIntegers8,
	LeastCommonMultiples8: LeastCommonMultiples8,
	Signs8: Signs8,
	Maxs8: Maxs8,
	Mins8: Mins8,
	Powers8: Powers8,
	Createu32: Createu32,
	Numberu32: Numberu32,
	Assignu32: Assignu32,
	u32IsValid: u32IsValid,
	WillOverflowu32: WillOverflowu32,
	ConvertToU32: ConvertToU32,
	ToStringu32: ToStringu32,
	ToHexStringu32: ToHexStringu32,
	Addu32: Addu32,
	AddIntou32: AddIntou32,
	Subtractu32: Subtractu32,
	SubtractIntou32: SubtractIntou32,
	Multiplyu32: Multiplyu32,
	MultiplyIntou32: MultiplyIntou32,
	Divideu32: Divideu32,
	DivideIntou32: DivideIntou32,
	Positiveu32: Positiveu32,
	Factorialu32: Factorialu32,
	Logarithmu32: Logarithmu32,
	NaturalLogarithmu32: NaturalLogarithmu32,
	Tanu32: Tanu32,
	Atan2_u32: Atan2_u32,
	Squarerootu32: Squarerootu32,
	Expu32: Expu32,
	DivisibleByu32: DivisibleByu32,
	Combinationsu32: Combinationsu32,
	Permutationsu32: Permutationsu32,
	EpsilonCompareu32: EpsilonCompareu32,
	GreatestCommonDivisoru32: GreatestCommonDivisoru32,
	GCDWithSubtractionu32: GCDWithSubtractionu32,
	LeastCommonMultipleu32: LeastCommonMultipleu32,
	Maxu32: Maxu32,
	Minu32: Minu32,
	Poweru32: Poweru32,
	Signed32BitIntegerIndefinateValue: Signed32BitIntegerIndefinateValue,
	NumberToSigned32Bit: NumberToSigned32Bit,
	Signed32BitAdd: Signed32BitAdd,
	Signed32BitSub: Signed32BitSub,
	Signed32BitMul: Signed32BitMul,
	Signed32BitDiv: Signed32BitDiv,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	Negate: Negate,
	Positive: Positive,
	Factorial: Factorial,
	Round: Round,
	BankersRound: BankersRound,
	Ceil: Ceil,
	Floor: Floor,
	Truncate: Truncate,
	Absolute: Absolute,
	Logarithm: Logarithm,
	NaturalLogarithm: NaturalLogarithm,
	Sin: Sin,
	Cos: Cos,
	Tan: Tan,
	Asin: Asin,
	Acos: Acos,
	Atan: Atan,
	Atan2: Atan2,
	Squareroot: Squareroot,
	Exp: Exp,
	DivisibleBy: DivisibleBy,
	Combinations: Combinations,
	Permutations: Permutations,
	EpsilonCompare: EpsilonCompare,
	GreatestCommonDivisor: GreatestCommonDivisor,
	GCDWithSubtraction: GCDWithSubtraction,
	IsInteger: IsInteger,
	GreatestCommonDivisorWithCheck: GreatestCommonDivisorWithCheck,
	LeastCommonMultiple: LeastCommonMultiple,
	Sign: Sign,
	Max: Max,
	Min: Min,
	Power: Power,
	Gamma: Gamma,
	LogGamma: LogGamma,
	LanczosApproximation: LanczosApproximation,
	Beta: Beta,
	Sinh: Sinh,
	Cosh: Cosh,
	Tanh: Tanh,
	Cot: Cot,
	Sec: Sec,
	Csc: Csc,
	Coth: Coth,
	Sech: Sech,
	Csch: Csch,
	Error: Error,
	ErrorInverse: ErrorInverse,
	FallingFactorial: FallingFactorial,
	RisingFactorial: RisingFactorial,
	Hypergeometric: Hypergeometric,
	HypergeometricDirect: HypergeometricDirect,
	BernouilliNumber: BernouilliNumber,
	AkiyamaTanigawaAlgorithm: AkiyamaTanigawaAlgorithm,
	CreateStringScientificNotationDecimalFromNumber: CreateStringScientificNotationDecimalFromNumber,
	CreateStringScientificNotationDecimalFromNumber15d2e: CreateStringScientificNotationDecimalFromNumber15d2e,
	CreateStringScientificNotationDecimalFromNumberAllOptions: CreateStringScientificNotationDecimalFromNumberAllOptions,
	CreateStringDecimalFromNumber: CreateStringDecimalFromNumber,
	CreateStringFromNumberWithCheck: CreateStringFromNumberWithCheck,
	GetMaximumDigitsForBase: GetMaximumDigitsForBase,
	GetFirstDigitPosition: GetFirstDigitPosition,
	GetSingleDigitCharacterFromNumberWithCheck: GetSingleDigitCharacterFromNumberWithCheck,
	GetDigitCharacterTable: GetDigitCharacterTable,
	CreateNumberFromDecimalStringWithCheck: CreateNumberFromDecimalStringWithCheck,
	CreateNumberFromDecimalString: CreateNumberFromDecimalString,
	CreateNumberFromStringWithCheck: CreateNumberFromStringWithCheck,
	CreateNumberFromParts: CreateNumberFromParts,
	ExtractPartsFromNumberString: ExtractPartsFromNumberString,
	ExtractPartsFromNumberStringFromSign: ExtractPartsFromNumberStringFromSign,
	ExtractPartsFromNumberStringFromPointOrExponent: ExtractPartsFromNumberStringFromPointOrExponent,
	ExtractPartsFromNumberStringFromExponent: ExtractPartsFromNumberStringFromExponent,
	GetNumberFromNumberCharacterForBase: GetNumberFromNumberCharacterForBase,
	CharacterIsNumberCharacterInBase: CharacterIsNumberCharacterInBase,
	StringToNumberArray: StringToNumberArray,
	StringToNumberArrayWithCheck: StringToNumberArrayWithCheck,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	WriteStringToStingStream: WriteStringToStingStream,
	WriteCharacterToStingStream: WriteCharacterToStingStream,
	WriteBooleanToStingStream: WriteBooleanToStingStream,
	SubstringWithCheck: SubstringWithCheck,
	Substring: Substring,
	AppendString: AppendString,
	ConcatenateString: ConcatenateString,
	AppendCharacter: AppendCharacter,
	ConcatenateCharacter: ConcatenateCharacter,
	SplitByCharacter: SplitByCharacter,
	IndexOfCharacter: IndexOfCharacter,
	SubstringEqualsWithCheck: SubstringEqualsWithCheck,
	SubstringEquals: SubstringEquals,
	IndexOfString: IndexOfString,
	ContainsCharacter: ContainsCharacter,
	ContainsString: ContainsString,
	ToUpperCase: ToUpperCase,
	ToLowerCase: ToLowerCase,
	EqualsIgnoreCase: EqualsIgnoreCase,
	ReplaceString: ReplaceString,
	ReplaceCharacter: ReplaceCharacter,
	Trim: Trim,
	StartsWith: StartsWith,
	EndsWith: EndsWith,
	SplitByString: SplitByString,
	StringIsBefore: StringIsBefore,
	arraysStringToNumberArray: arraysStringToNumberArray,
	arraysNumberArrayToString: arraysNumberArrayToString,
	arraysNumberArraysEqual: arraysNumberArraysEqual,
	arraysBooleanArraysEqual: arraysBooleanArraysEqual,
	arraysStringsEqual: arraysStringsEqual,
	arraysFillNumberArray: arraysFillNumberArray,
	arraysFillString: arraysFillString,
	arraysFillBooleanArray: arraysFillBooleanArray,
	arraysFillNumberArrayRange: arraysFillNumberArrayRange,
	arraysFillBooleanArrayRange: arraysFillBooleanArrayRange,
	arraysFillStringRange: arraysFillStringRange,
	arraysCopyNumberArray: arraysCopyNumberArray,
	arraysCopyBooleanArray: arraysCopyBooleanArray,
	arraysCopyString: arraysCopyString,
	arraysCopyNumberArrayRange: arraysCopyNumberArrayRange,
	arraysCopyBooleanArrayRange: arraysCopyBooleanArrayRange,
	arraysCopyStringRange: arraysCopyStringRange,
	arraysIsLastElement: arraysIsLastElement,
	arraysCreateNumberArray: arraysCreateNumberArray,
	arraysCreateBooleanArray: arraysCreateBooleanArray,
	arraysCreateString: arraysCreateString,
	arraysSwapElementsOfNumberArray: arraysSwapElementsOfNumberArray,
	arraysSwapElementsOfStringArray: arraysSwapElementsOfStringArray,
	arraysReverseNumberArray: arraysReverseNumberArray,
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	CreateLinkedListString: CreateLinkedListString,
	LinkedListAddString: LinkedListAddString,
	LinkedListStringsToArray: LinkedListStringsToArray,
	LinkedListStringsLength: LinkedListStringsLength,
	FreeLinkedListString: FreeLinkedListString,
	CreateLinkedListNumbers: CreateLinkedListNumbers,
	CreateLinkedListNumbersArray: CreateLinkedListNumbersArray,
	LinkedListAddNumber: LinkedListAddNumber,
	LinkedListNumbersLength: LinkedListNumbersLength,
	LinkedListNumbersIndex: LinkedListNumbersIndex,
	LinkedListInsertNumber: LinkedListInsertNumber,
	LinkedListSet: LinkedListSet,
	LinkedListRemoveNumber: LinkedListRemoveNumber,
	FreeLinkedListNumbers: FreeLinkedListNumbers,
	FreeLinkedListNumbersArray: FreeLinkedListNumbersArray,
	LinkedListNumbersToArray: LinkedListNumbersToArray,
	ArrayToLinkedListNumbers: ArrayToLinkedListNumbers,
	LinkedListNumbersEqual: LinkedListNumbersEqual,
	CreateLinkedListCharacter: CreateLinkedListCharacter,
	LinkedListAddCharacter: LinkedListAddCharacter,
	LinkedListCharactersToArray: LinkedListCharactersToArray,
	LinkedListCharactersLength: LinkedListCharactersLength,
	FreeLinkedListCharacter: FreeLinkedListCharacter,
	CreateDynamicArrayNumbers: CreateDynamicArrayNumbers,
	CreateDynamicArrayNumbersWithInitialCapacity: CreateDynamicArrayNumbersWithInitialCapacity,
	DynamicArrayAddNumber: DynamicArrayAddNumber,
	DynamicArrayNumbersIncreaseSize: DynamicArrayNumbersIncreaseSize,
	DynamicArrayNumbersDecreaseSizeNecessary: DynamicArrayNumbersDecreaseSizeNecessary,
	DynamicArrayNumbersDecreaseSize: DynamicArrayNumbersDecreaseSize,
	DynamicArrayNumbersIndex: DynamicArrayNumbersIndex,
	DynamicArrayNumbersLength: DynamicArrayNumbersLength,
	DynamicArrayInsertNumber: DynamicArrayInsertNumber,
	DynamicArraySet: DynamicArraySet,
	DynamicArrayRemoveNumber: DynamicArrayRemoveNumber,
	FreeDynamicArrayNumbers: FreeDynamicArrayNumbers,
	DynamicArrayNumbersToArray: DynamicArrayNumbersToArray,
	ArrayToDynamicArrayNumbersWithOptimalSize: ArrayToDynamicArrayNumbersWithOptimalSize,
	ArrayToDynamicArrayNumbers: ArrayToDynamicArrayNumbers,
	DynamicArrayNumbersEqual: DynamicArrayNumbersEqual,
	DynamicArrayNumbersToLinkedList: DynamicArrayNumbersToLinkedList,
	LinkedListToDynamicArrayNumbers: LinkedListToDynamicArrayNumbers,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	charToLowerCase: charToLowerCase,
	charToUpperCase: charToUpperCase,
	charIsUpperCase: charIsUpperCase,
	charIsLowerCase: charIsLowerCase,
	charIsLetter: charIsLetter,
	charIsNumber: charIsNumber,
	charIsWhiteSpace: charIsWhiteSpace,
	charIsSymbol: charIsSymbol,
	charCharacterIsBefore: charCharacterIsBefore,
	test: test
};